	SECTION "feta rasterbalkar", HOME

scybufr	set	rampage1
bgpbufr	set	rampage2
scybufw	set	rampage3
bgpbufw	set	rampage4
colours	set	rampage5

balkar	START_MUSIC_INT

	call	clearsprites
	ld	de, $0700
	call	flush

	ROMBANK	mathb
	ld	a, 1
	ldio	[rVBK], a
	ld	hl, font
	ld	de, _VRAM+$20*16
	ld	bc, 1024
	call	vmemcopy
	xor	a
	ldio	[rVBK], a

	ROMBANK	data2

	ld	hl, balkar_oamdata
	ld	de, oambuf
	ld	b, 160
	call	memcpsh

	ld	b, 1*8
	ld	hl, balkbgp
	call	setbgpal
	ld	b, 1*8
	ld	hl, balkobp
	call	setobpal

	ld	hl, balktil
	ld	de, _VRAM+$1000
	ld	bc, 73*16
	call	vmemcopy

	ld	hl, balkcol
	ld	de, colours
	ld	bc, 256
	call	vmemcopy

	ld	hl, balkmap
	ld	de, _SCRN0
	ld	bc, 1024
	call	vmemcopy

	ld	a, 48
	ldio	[rSCX], a

	ld	de, balkirq
	call	setlcdcirq
	ld	a, %00001000
	ldio	[rSTAT], a

	waitVBL
	ld	a, %10000011
	ldio	[rLCDC], a
	ld	a, oambuf>>8
	call	oamdma

	ld	a, 32
balkar_in
	push	af
	sra	a
	and	%01110000
	ldh	[gamma], a
	rst	$10
	;ld	a, oambuf>>8
	;call	oamdma
	MusicUpdate musicb
	ROMBANK	mathb
	xor	a
	ldio	[rLYC], a
	ldio	[rSCY], a
	;ld	a, 70
	;call	spmovl
	call	balkar_draw
	pop	af
	inc	a
	jr	nz, balkar_in

	ld	a, 128
	ldh	[gamma], a

balkar_main
	rst	$10
	MusicUpdate musicb
	ROMBANK	mathb
	xor	a
	ldio	[rLYC], a
	ldio	[rSCY], a
	call	balkar_draw
	ld	a, [counth]
	cp	time+2
	jr	nz, balkar_main

	ld	a, 255
balkar_ut
	push	af
	sra	a
	and	%01110000
	ldh	[gamma], a
	rst	$10
	;ld	a, oambuf>>8
	;call	oamdma
	MusicUpdate musicb
	ROMBANK	mathb
	xor	a
	ldio	[rLYC], a
	ldio	[rSCY], a
	;ld	a, 160
	;call	spmovd
	call	balkar_draw
	pop	af
	dec	a
	cp	32
	jr	nz, balkar_ut

	xor	a
	ldio	[rSCX], a

	ret
	
;**********************************************************************

balkar_draw
	ld	hl, scybufw
	ld	de, scybufr
	ld	bc, 512
	call	memcopy
	call	balkcls
	ldh	a, [countl]
	add	a, 154
	ld	b, 99
	call	balk_render
	ldh	a, [countl]
	cpl
	ld	b, 46
	call	balk_render
	ret

;**********************************************************************

balk_render
	ld	hl, sintab
	ldh	[beta], a
.loop	push	hl
	ld	a, l
	add	a, a
	and	%11000000
	sub	2
	ld	d, a	; frg
	ldh	a, [beta]
	add	a, l
	ld	l, a
	ld	a, [hl]
	add	a, 64
	sra	a
	sra	a
	add	a, 160
	ld	c, a	; bredd
	ld	a, [hl]
	add	a, 64
	swap	a
	and	15
	add	a, 8
	ld	e, a	; hjd
	ld	a, l
	sub	64
	ld	l, a
	ld	a, [hl]
	sra	a
	add	a, b	; ypos
	push	bc
	call	balk
	pop	bc
	pop	hl
	ldh	a, [gamma]
	ld	c, a
	ld	a, l
	add	a, 16
	cp	c
	ret	z
	ld	l, a
	jr	.loop

;**********************************************************************

balkcls	xor	a
	ld	hl, scybufw
	call	.screw
	ld	hl, bgpbufw
.screw	rept	144
	ld	[hl+], a
	endr
	ret

;**********************************************************************
	; rita en bgp-balk
	; a - y position	c - bredd
	; e - hjd		d - frg

balk	ld	b, e
	sra	b
	sub	b
	ld	l, a
	ld	h, scybufw>>8
	;ld	a, -32
	xor	a
	sub	b
	
	ld	b, 32
.loop	add	a, e
	jr	nc, .skip
	ld	[alpha], a
	ld	a, c
	cp	[hl]
	jr	c, .behind
	ld	[hl], c
	inc	h
	ld	[hl], d
	dec	h
.behind	ld	a, [alpha]
	inc	l
	sub	32
.skip	dec	d
	dec	d
	dec	b
	jr	nz, .loop
	ret

;**********************************************************************

balkirq	push	af
	push	hl

	ldio	a, [rLY]

	; scrolla
	ld	l, a
	ld	h, scybufr >> 8
	sub	[hl]
	cpl
	ldio	[rSCY], a

	; stt frg
	inc	h
	ld	l, [hl]
	ld	h, colours>>8
	ld	a, $82
	ld      [rBCPS], a
	ld	a, [hl+]
	ld	[rBCPD], a
	ld	a, [hl+]
	ld	[rBCPD], a

	pop	hl
	pop	af
	reti

	SECTION "balk-data", DATA, BANK[data2]

balkar_oamdata
y	set	140
x	set	70
p	set	1
	rept	3
	db	y,x,STRSUB("MSX",p,1),0
x	set	x+8
p	set	p+1
	endr
x	set	x+8
p	set	1
	rept	7
	db	y,x,STRSUB("MRDEATH",p,1),0
x	set	x+8
p	set	p+1
	endr
	DS	(40-10)*4

balktil	INCBIN	"ztab.tls"
balkmap	INCBIN	"ztab.map"

balkbgp	DW_RGB	$00, $00, $07
	DW_RGB	$00, $0f, $07
	DW_RGB	$00, $07, $03
	DW_RGB	$00, $00, $00

balkobp	DW_RGB	$00, $00, $07
	DW_RGB	$00, $00, $00
	DW_RGB	$07, $07, $07
	DW_RGB	$1f, $1f, $1f

balkcol
x	set	0
	rept	32
	DW_RGB	x, 0, x>>1
x	set	x+1
	endr
x	set	0
	rept	32
	DW_RGB	0, x>>1, x
x	set	x+1
	endr
x	set	0
	rept	32
	DW_RGB	0, x, x>>1
x	set	x+1
	endr
x	set	0
	rept	32
	DW_RGB	x, x>>1, 0
x	set	x+1
	endr
	
time	set	time+3
