	SECTION "palm-guy", HOME

palmguy	xor	a
	ldio	[rSTAT], a
	
	START_MUSIC_INT

	ROMBANK	data3

	call	clearsprites

	ld	a, 1
	ldio	[rVBK], a

	ld	hl, _SCRN0+18*32
	ld	bc, 14*32
	ld	a, 1
	call	vmemset

	ld	hl, pg_tiles+256*16
	ld	de, _VRAM+$800
	ld	bc, 104*16
	call	vmemcopy
	ld	de, pg_amap
	ld	hl, _SCRN0
	ld	bc, 20<<8+18
	call	drawmap

	xor	a
	ldio	[rVBK], a
	ld	hl, _SCRN0
	ld	bc, 20<<8+18
	ld	a, -128
	call	makemap
	ld	hl, pg_tiles
	ld	de, _VRAM+$800
	ld	bc, 256*16
	call	vmemcopy

	ld	hl, _SCRN0+18*32
	ld	bc, 14*32
	ld	a, $9a
	call	vmemset

	ld	b, 64
	ld	hl, pg_pal
	call	setbgpal
	ld	b, 8
	ld	hl, pg_spal
	call	setobpal

	ld	hl, pg_oamdata
	ld	de, oambuf
	ld	bc, 160
	call	vmemcopy

	ld	a, oambuf>>8
	call	oamdma

	xor	a
	ldio	[rSCX], a
	ldio	[rSCY], a

	call	initline_xor

	xor	a
	ldio	[rSTAT], a
	ld	de, retint
	call	setlcdcirq

	ld	a, %10000111
	ldio	[rLCDC], a

pg_main	waitVBL

	ld	a, $d0
	ldio	[rHDMA1], a
	ld	a, $80
	ldio	[rHDMA3], a
	xor	a
	ldio	[rHDMA2], a
	ldio	[rHDMA4], a
	ld	a, $7f
	ldio	[rHDMA5], a	

	MusicUpdate musicb
	ROMBANK	data3

	ld	hl, counter
	inc	[hl]

	ld	hl, $d000
	call	qcls

	; find coords in cube
	ld	a, [counter]
	swap	a
	and	$f0
	ld	l, a
	ld	a, [counter]
	swap	a
	and	$0f
	add	a, cube_data>>8
	ld	h, a
	ld	de, cube_wires

	ld	b, 8
.loop	push	bc
	push	de
	push	hl
	
	ld	a, [de]
	ldh	[alpha], a
	inc	e
	ld	a, [de]
	ldh	[beta], a

	ld	b, 0
	ld	a, [alpha]
	ld	c, a
	push	hl
	add	hl, bc
	
	ld	a, [hl+]
	add	a, 64
	sra	a
	ld	d, a
	ld	a, [hl-]
	add	a, 64
	sra	a
	ld	e, a
	pop	hl
	push	de

	ld	a, [beta]
	ld	c, a
	add	hl, bc
	
	ld	a, [hl+]
	add	a, 64
	sra	a
	ld	d, a
	ld	a, [hl-]
	add	a, 64
	sra	a
	ld	e, a
	
	ld	hl, [sp+4]
	ld	a, [hl]

	pop	hl

	rra
	rra

	call	line	

	pop	hl
	pop	de
	inc	e
	inc	e
	pop	bc
	djnz	.loop

	ld	hl, $d000
	call	qxorfil
	ld	hl, $d001
	call	qxorfil

	ldh	a, [counth]
	cp	time+3
	jp	nz, pg_main

	ret

	SECTION "palmguy data", DATA, BANK[data3]

pg_amap	 incbin	"palmguy.atr"
pg_tiles incbin	"palmguy.tls"
pg_pal	 incbin	"palmguy.pal"

pg_spal	DW_RGB	31,31,31
	DW_RGB	15,15,15
	DW_RGB	15,15,15
	DW_RGB	31,31,31

pg_oamdata
t	set	0
x	set	75
	rept	8
y	set	75
	rept	4
	db	y,x,t,0
t	set	t+2
y	set	y+16
	endr
x	set	x+8
t	set	t+8
	endr
	rept	8
	db	0,0,0,0
	endr

cube_wires
	;db	0, 7, 1, 6, 3, 4, 2, 5
	db	0*2, 4*2
	db	1*2, 5*2
	db	2*2, 6*2
	db	3*2, 7*2
	db	0*2, 2*2
	db	1*2, 3*2
	db	4*2, 6*2
	db	5*2, 7*2
	;db	0*2, 1*2
	;db	2*2, 3*2
	;db	4*2, 5*2
	;db	6*2, 7*2

	SECTION	"cube", DATA[$7000], BANK[data3]
cube_data
	incbin	"cube.bin"
time	set	time+3